package test;

/*******************************************************************************
 *                                  ޗǍ                                   *
 *                            t@C̔r{                         *
 *******************************************************************************
 *                                                                             *
 *-----------------------------------------------------------------------------*
 * Revision|                                                                   *
 *-----------------------------------------------------------------------------*
 * R00     | First Release                          | 2003-10-10 |             *
 *******************************************************************************/
/*
 * Date=[UTC]$Id$
 *
 * Copyright (C) 2002 by WIPS.
 * All rights reserved.
 *
 */
import java.nio.*;
import java.nio.channels.*;
import java.io.*;

public class ExclusiveFile {

	public  String FileName; // need full-path
	private int    Interval; //msec
	private int    MaxLoops; //Max of loop counter

	private FileChannel channel = null;
  	private FileLock    lock    = null;


	
	public ExclusiveFile(String filename, int Inter, int Max) {
		FileName = filename;
		Interval = Inter;
		MaxLoops = Max  ;
	}

	private RandomAccessFile Open(String FName) {
		try {
			return new RandomAccessFile(FName, "rw");
		}catch(Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	private FileLock TryLock() {
		try {
			return channel.tryLock();
		}catch(Exception e) {
			return null;
		}
	}
	
	
	
	public boolean LockIt(){
		RandomAccessFile raFile = null;
		
		for(int i=0; i<MaxLoops; i++) {
			if( (raFile != null) || (raFile = Open(FileName)) != null) {
				channel = raFile.getChannel();
				if((lock = TryLock()) != null) {
					System.out.println("Success to get Lock!");
					return true;
				}
			}
			System.out.println("Cannot get Lock will sleep "+Interval+"msecs");
			try {
				Thread.sleep(Interval);
			}catch(Exception e){;}
		}
		System.out.println("cannot get lock file something is bad("+FileName+") and Inert="+Interval+" Loop="+MaxLoops);
		return false;
	}

	public boolean ReleIt() {
		try {
			lock.release();
			channel.close();
			return true;
		  
		} catch(Exception e) {
			return false;
		} 
	}

	public static void main(String[] args){
		ExclusiveFile exf = new ExclusiveFile(args[0], 1000, 10);
		if(exf.LockIt()) {
			System.out.println("Success! lock!");
	                javax.swing.JOptionPane.showMessageDialog(null, "Release Lock?");
			exf.ReleIt();
			System.exit(0);
		} else {
			System.out.println("Fail???");
			System.exit(-1);
		}
	}
}
